# NOTE: Derived from blib/lib/Graphics/ColorPicker.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Graphics::ColorPicker;

#line 637 "blib/lib/Graphics/ColorPicker.pm (autosplit into blib/lib/auto/Graphics/ColorPicker/cp216_ds.al)"
################################################
# return 216 color page and digits
#
# input:   clear dot image,
#	   border 	[default 0]
#	   square size	[default 9]
# returns: html text for 216 color page & digits
#
sub cp216_ds {
  my ($clrimg,$border,$size) = @_;
  $clrimg =~ m|([^/]+)$|;
  my $updimg = $` . 'updown.gif';
  $border = 0 unless $border;
  $size = 9 unless $size;
  $size -= $border;
  
  my $head .= q|<html>
<script language="javascript1.2">
rgb = new Array(3);
color = new Array('RED','GREEN','BLUE');
clr = new Array('r','g','b');
hexd = new Array(0,1,2,3,4,5,6,7,8,9,'A','B','C','D','E','F');
icache = new Image();
icache.src = "| . $clrimg . q|";
var hex;
function init() {
  if (parent.doce == '') return false;
  if (parent.uno == '') parent.uno = parent.doce;
  self.document.forms.rgb.hex.value = parent.doce;
  self.hexclk();
  return true;
}

function doSubmit() {
  if (parent.opener == null) {
    alert("You can NOT Submit,\nwindow has no opener.\nUse Close to exit.");
    return true; // have to return something
  }
  parent.opener.colorhex = hex;
  parent.close();
  return true;
}

function doRestore() {
  parent.doce = parent.uno;
  init();
  return true;
}

function flipc24m() {
  with (parent._picker) {
    if (c24flip == 0) {
      pict.plot.src = lcache.src;
      c24flip = 1;
    } else {
      pict.plot.src = dcache.src;
      c24flip = 0;
    }
  }
  return false;
}

function update() {
  parent.doce = hex;
  var me = parent._sample.document;
  var t = '<font color=';
  var whitefont = t + 'white>';
  var hexfont = t + '"#' + hex + '">';
  var blackfont = t + 'black>';
  t = '<td width=|. ($colwidth-15) . q| id="';
  var td_bgblack = t + 'dark">';
  var td_bghex = t + 'clrd">';
  var td_bgwhite = t + 'lite">';
  var end = '</font></td>';
  me.write('<html><head>'+"\n");
  me.writeln('<style type="text/css">')
  me.writeln('  #dark{background-color: black;font-family: VERDANA,ARIAL,HELVETICA,SAN-SERIF;font-size: 16px !important;font-weight: bold;}');
  me.writeln('  #lite{background-color: white;font-family: VERDANA,ARIAL,HELVETICA,SAN-SERIF;font-size: 16px !important;font-weight: bold;}');
  me.writeln('  #clrd{background-color: #' + hex + ';font-family: VERDANA,ARIAL,HELVETICA,SAN-SERIF;font-size: 16px !important;font-weight: bold;}');
  me.writeln('</style>');
  me.writeln('</head>');
  me.writeln('<body bgcolor="#ffffff"><table cellspacing=5 cellpadding=5 border=0>');
  me.writeln('<tr align=center valign=middle>');
    me.writeln(td_bgwhite + hexfont + hex + end);
    me.writeln(td_bghex + whitefont + hex + end + '</tr>');
  me.writeln('<tr align=center valign=middle>');
    me.writeln(td_bgblack + hexfont + hex + end);
    me.writeln(td_bghex + blackfont + hex + end + '</tr>');
  me.writeln('</table></body></html>');
  me.close();
  return true;
}

ishex = new RegExp("^([a-zA-Z0-9]{2})([a-zA-Z0-9]{2})([a-zA-Z0-9]{2})$");
function ckhex(s) {
  if ( s.match(ishex) ) {
    rgb[0] = eval('0x' + s.charAt(0) + s.charAt(1)); // r
    rgb[1] = eval('0x' + s.charAt(2) + s.charAt(3)); // g
    rgb[2] = eval('0x' + s.charAt(4) + s.charAt(5)); // b
    return true;
  } else {
    alert(s + "\nmust be 6 RGB elements\nhexadecimal a-zA-Z0-9" );
    document.forms.rgb.hex.value = "";
    return false;
  }
}

function setrgb() {
  document.forms.rgb.r.value = rgb[0]; // r
  document.forms.rgb.g.value = rgb[1]; // g
  document.forms.rgb.b.value = rgb[2]; // b
}

function hexclk() {
  var s = document.forms.rgb.hex.value;
  if ( ckhex(s) ) { 
    hex = s;
    setrgb();
    update();
  }
}

function newco(i,c) {
  var newcolor = document.forms.rgb[clr[c]];
  var n = newcolor.value;
  if (n == '') return false;
  if (isNaN(n)) {
    alert(color[c] + ' is not a number');
    newcolor.value = "";
    return false;
  }
  if ( n < 0 | . '||' . q| n > 255 ) {
    alert(color[c] + " out of range\nmust be 0-255");
    newcolor.value = "";
    return false;
  }
  n = Number(n) + Number(i);
  if ( n < 0 ) n = 0;
  if ( n > 255 ) n = 255;
  if ( rgb[c] != n ) {
    rgb[c] = n;
    newcolor.value = n;
    sethex();
  }
  return false; // always!
}

function sethex() {
  if (isNaN(rgb[0]) | .'||'. q| isNaN(rgb[1]) | .'||'. q|isNaN(rgb[2])) return false;
  hex = "" + tohex(rgb[0]) + tohex(rgb[1]) + tohex(rgb[2]);
  document.forms.rgb.hex.value = hex;
  update();
}

function tohex(n) {
  var h = "" + hexd[n>>4] + hexd[n%16];
  return h;
}

function clrupd() {
  document.forms.rgb.r.blur();
  document.forms.rgb.g.blur();
  document.forms.rgb.b.blur();
  document.forms.rgb.hex.blur();
  return true;
}

function clk216(r,g,b) {
  hex = "" + r + g + b;
  document.forms.rgb.hex.value = "" + hex;
  rgb[0] = eval('0x' + r);
  rgb[1] = eval('0x' + g);
  rgb[2] = eval('0x' + b);
  setrgb();
  update();
  return false;
}

function populate(n) {
  for (var i=0; i < n; i++) {
    var I = 'X' + i;
    document[I].src = icache.src;
  }
  return true;
}

</script>
<style>
A.NU { 
  color: #ffffcc;
  background: transparent;
  font-family: VERDANA,ARIAL,HELVETICA,SAN-SERIF;
  font-size: 12px !important;
  font-weight: bold;
  text-decoration: none;
}

#txt {
  font-family: VERDANA,ARIAL,HELVETICA,SAN-SERIF;
  font-size: 10px !important;  
}

</style>
</head>
|;

#####################################

  my $num = 0;

  my $digitbox = q|
<MAP name="RED">
<AREA OnClick="return(newco(1,0));"
shape=rect
coords=0,0,16,7
href="+1"
OnMouseOver="return(clrupd());">
<AREA OnClick="return(newco(-1,0));"
shape=rect
coords=0,8,16,16
href="-1"
OnMouseOver="return(clrupd());">
</map>

<MAP name=GREEN>
<AREA OnClick="return(newco(1,1));"
shape=rect
coords=0,0,16,7
href="+1"
OnMouseOver="return(clrupd());">
<AREA OnClick="return(newco(-1,1));"
shape=rect
coords=0,8,16,16
href="-1"
OnMouseOver="return(clrupd());">
</map>

<MAP name=BLUE>
<AREA OnClick="return(newco(1,2));"
shape=rect
coords=0,0,16,7
href="+1"
OnMouseOver="return(clrupd());">
<AREA OnClick="return(newco(-1,2));"
shape=rect
coords=0,8,16,16
href="-1"
OnMouseOver="return(clrupd());">
</map>

<form name=rgb action="javascript:void('');" method=post>
<table cellspacing=0 cellpadding=0 border=0>
<tr><td colspan=3 id="txt">web colors</td></tr>
<tr>
<td>
<a href="" OnClick="return false;" OnMouseOver="return(clrupd());"><img name=X|. $num++ . q| width=10 height=180 alt="" border=0></a></td>
<td>

<table cellspacing=1 cellpadding=0 border=0>
<tr><td colspan=2>
<a href="" OnClick="return false;" OnMouseOver="return(clrupd());"><img name=X|. $num++ . q| width=60 height=10 alt="" border=0></a></td></tr>
<tr align=center>
  <td id="txt"><font color=red>RED</font><br>
  <input type=text name=r size=3 OnChange="newco(0,0);"></td>
  <td id="txt">&nbsp;<br><img src="| . $updimg . q|" width=16 height=16 border=1 alt="" usemap="#RED"></td></tr>
<tr align=center>
  <td id="txt"><font color=green>GREEN</font><br>
  <input type=text name=g size=3 OnChange="newco(0,1);"></td>
  <td id="txt">&nbsp;<br><img src="| . $updimg . q|" width=16 height=16 border=1 alt="" usemap="#GREEN"></td></tr>
<tr align=center>
  <td id="txt"><font color=blue>BLUE</font><br>
  <input type=text name=b size=3 OnChange="newco(0,2);"></td>
  <td id="txt">&nbsp;<br><img src="| . $updimg . q|" width=16 height=16 border=1 alt="" usemap="#BLUE"></td></tr>
<tr align=center><td colspan=2 id="txt">hex color<br>
  <input type=text name=hex size=6 OnChange="hexclk();"></td></tr>
<tr><td colspan=2>
<a href="" OnClick="return false;" OnMouseOver="return(clrupd());"><img name=X|. $num++ . q| width=60 height=10 alt="" border=0></a></td></tr>
</table>

</td>
<td>
<a href="" OnClick="return false;" OnMouseOver="return(clrupd());"><img name=X|. $num++ . q| width=10 height=180 alt="" border=0></a></td>
</tr>
</table>
</form>
|;

##########################################

  my $colortab = q|
<table cellpadding=0 cellspacing=0 border=1>
<tr><td><table cellpadding=0 cellspacing=0 border=|. $border . q|>
<tr>
|;

  my @forward = ('00','33','66','99','CC','FF');
  my @reverse = reverse @forward;

  my $c = 0;
  my ($r,$g,$b);
  my $line = sub {
    my ($r,$g,$b,$n) = @_;
    return qq|  <td bgcolor="#$r$g$b"><a OnClick="return(clk216('$r','$g','$b'));" href="$r$g$b"><img name=X|.
	$n . qq| height=$size width=$size alt="$r$g$b" border=0></a></td>\n|;
  };

  foreach $b (@forward) {
    foreach $g (@forward) {
      foreach $r (@reverse) {
#	next if $separate && $r eq $b && $r eq $g;
	if ( ++$c > 6 ) {
	  $colortab .= qq|</tr>\n<tr>\n|;
	  $c = 1;
	}
	$colortab .= &$line($r,$g,$b,$num++);
      }
    }
  }
#unless ( $separate ) {
  $colortab .= "</tr>\n</tr>\n";
  foreach (@reverse) {
    $colortab .= &$line($_,$_,$_,$num++)
  }
#}
  $colortab .= q|</tr>
</table>
</td></tr>
</table>
|;

# use on click as workaround for buggy Opera browser.
  my $butable = [
#	'Submit'	=> 'javascript:void doSubmit();',
	'Submit'	=> 'javascript:void(0);" OnMouseDown="doSubmit();return false;',
	'','',
#	'Restore'	=> 'javascript:void doRestore();',
	'Restore'	=> 'javascript:void(0);" OnClick="doRestore();return false;',
	'','',
	'Close'		=> 'javascript:void (0);" OnClick="parent.close();return false;',
  ];

  return $head . q|<body bgcolor="#ffffff" OnLoad="populate(| . $num . q|);">
<table cellspacing=0 cellpadding=0 border=0>
<tr align=center valign=middle>
  <td width=|. $colwidth . q|>|. $colortab . q|</td>
  <td width=|. $colwidth . q|>|. $digitbox .
&make_buttons('#0000cc',60,$butable) . qq|
<font id="txt">$VERSION</font>
</td></tr>
</table>
</body>
</html>
|;
}

# end of Graphics::ColorPicker::cp216_ds
1;
